# Arduino

This repository contains Arduino sketches and Arduino libraries maintained by the RUG/DTPA group.
[Web link to DTPA](https://www.rug.nl/research/discrete-technology-production-automation/)


## Sketches

- Blinky: A hello world example.

- Nexus_Omni4WD: Firmware for the Nexus Omni4WD chassis for setting the wheel speeds independently. It is used to control the robot from ROS.

![ ](figures/NexusOmni4WD.png  "Nexus Omni 4WD")

*sketches/Nexus_Omni4WD*
This folder contains the Arduino sketch of the firmware. The program works as a simple command interpreter for controlling the wheel speeds  independently. To compile, use the libraries provided in the *extra/factory_10011.zip* archive.

*extra/carcomm*
*testcarcom.py* is a small Python application to test the Nexus_Omni4WD firmware (sketch). The python application sends data packages to set the wheel speeds.

The Arduino controller 10009 with io expansion shield on the Omni4WD  is Duemilanove/ATMEGA328 compatible.



## Libraries

- NativeDDS: Arduino library for a software implemented Direct Digital Synthesizer. 

- TrueRMS: Arduino library that calculates the average, rms and power of DC+AC input signals, measured with the ADC. 
